import { type EditorState, type Extension } from "@codemirror/state";
export interface Range {
    anchor: number;
    head: number;
}
export declare const FakeSelection: import("@codemirror/state").StateEffectType<Range>;
/**
 * A "block" cursor is a solid rectangle over a character.
 * A "column" cursor is a vertical line in between characters.
 */
export type CursorStyle = "block" | "column";
export interface FakeSelectionConfig {
    /**
     * The length of a full cursor blink cycle, in milliseconds.
     * Can be set to 0 to disable blinking.
     * @default 1200
     */
    cursorBlinkRate?: number;
    /**
     * Style of cursor to draw.
     * @default "block"
     */
    cursorStyle?: CursorStyle;
    /**
     * Whether to show a cursor for non-empty ranges.
     * @default true
     */
    drawRangeCursor?: boolean;
}
/**
 * CodeMirror extension to imitate selections in replay.
 */
export declare function fakeSelection(config?: FakeSelectionConfig): Extension;
export declare function getDrawFakeSelectionConfig(state: EditorState): FakeSelectionConfig;
